<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcProjectile Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcProjectile Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcProjectile" --><!-- doxytag: inherits="iBase" -->
<p>This is a projectile property class.  
 <a href="structiPcProjectile.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="projectile_8h_source.html">propclass/projectile.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcProjectile:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcProjectile.png" usemap="#iPcProjectile_map" alt=""/>
  <map id="iPcProjectile_map" name="iPcProjectile_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,83,24"/>
</map>
 </div></div>

<p><a href="structiPcProjectile-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcProjectile.html#a936787c2a6210262210d235c78d8fc43">Interrupt</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Interrupt a movement.  <a href="#a936787c2a6210262210d235c78d8fc43"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcProjectile.html#a54c3fb5291675b9409597438bbdea702">IsMoving</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if currently moving.  <a href="#a54c3fb5291675b9409597438bbdea702"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcProjectile.html#a57d828176d12edba00374ed7d7826c1b">Start</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;direction, float speed, float maxdist, int maxhits)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Start a movement of this projectile from its current position.  <a href="#a57d828176d12edba00374ed7d7826c1b"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a projectile property class. </p>
<p>This class controls movement of a projectile from one spot to another (or in some direction).</p>
<p>This property class can send out the following messages:</p>
<ul>
<li>'cel.move.interrupted' (old 'pcprojectile_stopped'): the projectile movement has stopped but no object was hit.</li>
<li>'cel.move.collision' (old 'pcprojectile_hit'): we hit some object (entity, intersection, meshname). If we hit a mesh that is not an entity then this message will still be sent but with entity equal to 0 (you can then use the 'meshname' to see what mesh has been hit).</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.move.projectile.action.' if you want to access this action through a message):</p>
<ul>
<li>Start: start movement in some direction. Parameters 'direction' (vector3), 'speed' (float), 'maxdist' (float), and 'maxhits' (long).</li>
<li>Interrupt: interrupt the current movement.</li>
</ul>
<p>This property class supports the following properties:</p>
<ul>
<li>moving (bool, read only): returns true if currently moving. </li>
</ul>

<p>Definition at line <a class="el" href="projectile_8h_source.html#l00047">47</a> of file <a class="el" href="projectile_8h_source.html">projectile.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a936787c2a6210262210d235c78d8fc43"></a><!-- doxytag: member="iPcProjectile::Interrupt" ref="a936787c2a6210262210d235c78d8fc43" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcProjectile.html#a936787c2a6210262210d235c78d8fc43">iPcProjectile::Interrupt</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Interrupt a movement. </p>

</div>
</div>
<a class="anchor" id="a54c3fb5291675b9409597438bbdea702"></a><!-- doxytag: member="iPcProjectile::IsMoving" ref="a54c3fb5291675b9409597438bbdea702" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcProjectile.html#a54c3fb5291675b9409597438bbdea702">iPcProjectile::IsMoving</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if currently moving. </p>

</div>
</div>
<a class="anchor" id="a57d828176d12edba00374ed7d7826c1b"></a><!-- doxytag: member="iPcProjectile::Start" ref="a57d828176d12edba00374ed7d7826c1b" args="(const csVector3 &amp;direction, float speed, float maxdist, int maxhits)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcProjectile.html#a57d828176d12edba00374ed7d7826c1b">iPcProjectile::Start</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>direction</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>speed</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxdist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>maxhits</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Start a movement of this projectile from its current position. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">direction</td><td>is the direction to go in. </td></tr>
    <tr><td class="paramname">speed</td><td>is the speed in units per second. </td></tr>
    <tr><td class="paramname">maxdist</td><td>is the maximum distance to move at which point we will stop and send a pcprojectile_stopped message. </td></tr>
    <tr><td class="paramname">maxhits</td><td>is the maximum number of hits at which point we will stop and send a pcprojectile_stopped message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>false if we couldn't start the movement (usually this means the projectile is already moving). </dd></dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="projectile_8h_source.html">projectile.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
